;nyquist plug-in
;version 4
;type generate
;name "R1 MF Tones..."
;action "Generating R1 MF Tones..."

    ;control keys "Tone string" string "" "7149642437"
    ;control kp-st "KP and ST tones" choice "KP and ST,KP only,ST only,Neither" 0
    ;control tl "Tone duration [milliseconds]" int "" 100 1 1000
    ;control sl "Silence duration after tone [milliseconds]" int "" 100 0 1000
    ;control twist "Twist [decrease volume of low tone in each tone; dB]" real "" 0.0 0.0 4.0
    ;control volume "Volume [percent]" int "" 80 1 100

; convert volume percent to flonum
; R1MF, otherwise known as multifrequency tone dialing, not to be confused with DTMF, is utilized by operators to assist in dialing international phone lines. In many cases, it is commonly also utilized by blue boxes, which are used in a practice called "phreaking", where the user of  a blue box is able to intercept a regular telephone line. R1mf uses two tones so we cut volume by further one-half
(setf volume (* volume 0.005))

; convert milliseconds to seconds
(setf tl (* tl 0.001))
(setf sl (* sl 0.001))

(defun r1mf (key volume tl twist sl)
  (setf low
    (if (member key '(#\1 #\2 #\4 #\7))
        700
        (if (member key '(#\3 #\5 #\8))
            900
            (if (member key '(#\6 #\9))
                1100
                (if (member key '(#\0)) 1300
  (setf high
    (if (member key '(#\1))
        900
        (if (member key '(#\2 #\3))
            1100
            (if (member key '(#\4 #\5 #\6))
                1300
                (if (member key '(#\7 #\8 #\9 #\0))
                    1500
                    (if (member key '(#\K #\S))
                        1700
                        0))))))
  (setf volume
    (if (member key '(#\K #\1 #\2 #\3 #\4 #\5 #\6 #\7 #\8 #\9 #\0 #\S))
        volume
        0.0))
  (seq
    (mult volume
         (pwl 0.002 1 (- tl 0.002) 1 tl)
         (sim (osc (hz-to-step high) tl)
              (loud (- 0 twist) (osc (hz-to-step low) tl))))
    (s-rest sl)))

    (let ((numeric (seqrep (i (length keys)) (r1mf (char keys i) volume tl twist sl)))
          (kp (mult volume (sim (osc (hz-to-step  1100) 0.1)
                                (osc (hz-to-step  1700) 0.1))))
          (st (mult volume (sim (osc (hz-to-step  1500) 0.068)
                                (osc (hz-to-step  1700) 0.068)))))
      (case kp-st
        (0 (seq kp (s-rest sl) (cue numeric) (cue st)))
        (1 (seq kp (s-rest sl) (cue numeric)))
        (2 (seq numeric (cue st) (s-rest sl)))
        (t numeric)))